/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package meetingroom.ui.reservasi;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import meetingroom.ui.login.HomeScreen;
import meetingroom.util.MyConnection;

/**
 *
 * @author Legion
 */
public class PersetujuanRuanganScreen extends javax.swing.JFrame {

    private final Connection connection = new MyConnection().connect();
    private DefaultTableModel tabmode;
    
    /**
     * Creates new form PersetujuanRuanganScreen
     */
    public PersetujuanRuanganScreen() {
        initComponents();
        dataTable();
        setExtendedState(JFrame.MAXIMIZED_HORIZ);
    }
    
    String username;
    
    public String setUsername(String user) {
        System.out.println("PengajuanRuanganScreen : " + user);
        return this.username = user;
    }
    
    private void dataTable() {
        Object[] Baris = {"ID", "No Reservasi", "Agenda", "Tanggal", "Ruangan", "Peserta", "Pemohon"};
        tabmode = new DefaultTableModel(null, Baris);
        tableOtorisasi.setModel(tabmode);
        try {
            Statement stat = connection.createStatement();
            String sql = "SELECT * FROM RESERVASI WHERE STATUS = '2' ORDER BY RESERVASI_DATE";
            ResultSet result = stat.executeQuery(sql);
            if (result != null) {
                while (result.next()) {
                    String id = result.getString("id_reservasi");
                    String a = result.getString("no_reservasi");
                    String b = result.getString("agenda");
                    String c = result.getString("reservasi_date");
                    String d = result.getString("id_ruang");
                    String e = result.getString("peserta");
                    String f = result.getString("request_by");
                    String[] data = {id, a, b, c, d, e, f};
                    tabmode.addRow(data);
                }
            } else {
                JOptionPane.showMessageDialog(null, "Data Reservasi tidak ditemukan");
            }
        } catch (SQLException e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tableOtorisasi = new javax.swing.JTable();
        btnProses = new javax.swing.JButton();
        btnBatal = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel2.setFont(new java.awt.Font("Segoe UI Light", 1, 24)); // NOI18N
        jLabel2.setText("Persetujuan Pengajuan Ruangan");

        tableOtorisasi.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "No Reservasi", "Agenda", "Tanggal", "Ruangan", "Peserta", "Pemohon"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tableOtorisasi.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tableOtorisasiMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(tableOtorisasi);

        btnProses.setText("Proses");
        btnProses.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnProsesActionPerformed(evt);
            }
        });

        btnBatal.setText("Batal");
        btnBatal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBatalActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnProses)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBatal))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jLabel2)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 554, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(54, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnBatal, btnProses});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addGap(33, 33, 33)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnProses)
                    .addComponent(btnBatal))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 378, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        setBounds(700, 300, 634, 538);
    }// </editor-fold>//GEN-END:initComponents

    private void btnBatalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBatalActionPerformed
        new HomeScreen().setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_btnBatalActionPerformed

    private void btnProsesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnProsesActionPerformed
        int ok = JOptionPane.showConfirmDialog(null, "Apakah Yakin untuk Proses Data?", "Konfirmasi Dialog", JOptionPane.YES_NO_CANCEL_OPTION);
        if (ok == 0) {
            String sql = "UPDATE RESERVASI SET APPROVED_BY = ? , APPROVED_DATE = ? , STATUS = '1' WHERE ID_RESERVASI = '" + idReservasi + "'";
            try {
                PreparedStatement stat = connection.prepareStatement(sql);
                stat.setString(1, username);
                stat.setTimestamp(2, java.sql.Timestamp.valueOf(java.time.LocalDateTime.now()));
                stat.executeUpdate();
                JOptionPane.showMessageDialog(null, "Data Berhasil Disetujui");
                dataTable();
            } catch (SQLException e) {
                JOptionPane.showMessageDialog(null, "Data Gagal Dihapus" + e);
            }
        }
    }//GEN-LAST:event_btnProsesActionPerformed

    private String idReservasi = "";
    
    private void tableOtorisasiMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tableOtorisasiMouseClicked
        int bar = tableOtorisasi.getSelectedRow();
        String a = tabmode.getValueAt(bar, 0).toString();
        idReservasi = a.toString();
    }//GEN-LAST:event_tableOtorisasiMouseClicked

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(PersetujuanRuanganScreen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(PersetujuanRuanganScreen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(PersetujuanRuanganScreen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(PersetujuanRuanganScreen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new PersetujuanRuanganScreen().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnBatal;
    private javax.swing.JButton btnProses;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tableOtorisasi;
    // End of variables declaration//GEN-END:variables
}
